d_camfile_plot <- function(camera_data,starttime,endtime,nameoutputfile){

  axislimits <- seq(from=starttime,to=endtime,by=100)
  timesconv <- c("1:00AM","2:00AM","3:00AM","4:00AM","5:00AM","6:00AM","7:00AM","8:00AM","9:00AM","10:00AM","11:00AM","12:00PM","1:00PM","2:00PM","3:00PM","4:00PM","5:00PM","6:00PM","7:00PM","8:00PM","9:00PM","10:00PM","11:00PM","12:00AM")
  labels <- c(timesconv[seq(from=starttime/100, to=endtime/100, by=1)])
  
pdf(paste(nameoutputfile,".pdf"))
  #pdf("nameoutputfile555.pdf")
  
  #Loop for generating plots of each Bee.
for(i in unique(camera_data$ID)){
  
  #Create temporary table with data from 1 ID (Bee)
  temp <- subset(camera_data,camera_data$ID == i)
  
  #save CSV for each ID
  #######write.csv(temp,paste(i,".csv"),row.names=FALSE,sep=",")
  
  #Plot each bee. X = Date and Y = Time of Day
  plot(temp$Age,temp$Time,main = paste(i),pch=16,yaxt="n",xlab="Age (days)",ylab="",ylim=c(starttime/2400,endtime/2400))
  
  #Determining labels for Y axis.
  axis(side=2,at=(seq(from=starttime,to=endtime,by=100)/2400),las=2,labels=labels)
  #axis(side=1,at=temp$NewDate,labels=temp$Date)
  
}
  #Finalize pdf 
dev.off()
}





#Parameter of graph margins. Thjis determines how much space is between each plot.
#par(mfrow=c(2,1),mar=c(2,5,1.5,1.5))

#hist(temp$Time,breaks=seq(from=700/2400,to=1900),main="",xlim=c(700/2400,1900/2400))
