binning <- function(TimeCol,firstvarcol,lastvarcol,maxGap){
  
  for(i in recordnamelist){
    filename <- paste(sub(pattern=".csv",replacement="",x=i),"_formatted_avg-dup_truncated.csv",sep="")
    
    fileName <- file.path(workdir,filename)
    
    myHeader <- read.table(fileName, header = TRUE, nrows = 1,sep = ",", skip = 0)
    
    
    myData1A <- read.table(fileName, header = TRUE, sep = ",",skip = 0, stringsAsFactors = FALSE, comment.char = "",col.names = names(myHeader))
    
    myData1 <- myData1A[, c(TimeCol = TimeCol, valCols = seq(from=firstvarcol,to=lastvarcol,by=1))]
    
    myData1[, TimeCol[1]] <- as.POSIXct(strptime(x = paste(myData1[,TimeCol[1]], myData1[, TimeCol[1]]), format = "%Y%m%d%H%M" , tz = "GMT"))
    
    myList <- do.call(Import, list(x = myData1, tsCol = TimeCol, valCols = seq(from=firstvarcol,to=lastvarcol,by=1), sumCols = 1,
                                   rowDurationSeconds = (minutesperbin*60), maxGap = maxGap, 
                                   verbose = 0, tz = "GMT"))
    
    
    Catbins <- CatBin(TimeCol=TimeCol, startX = firstvarcol, endX = lastvarcol, Avg=FALSE, lum=NA, sizePts=minutesperbin, binPts=1,modulo=1440, startData=1, myData=myList$df)
    
    tempfile <- data.frame(Catbins$TimeBins,t(Catbins$DataList))
    colnames(tempfile) <- c("Datetime","TEMP","HR","RR","SBP","DBP")
    
    assign(i,tempfile,.GlobalEnv)
    
    write.csv(tempfile,paste(sub(pattern=".csv",replacement="",x=i),"_formatted_avg-dup_truncated_binned.csv",sep=""),row.names=FALSE)
  }
}
