#' Function to choose binning interval
#'
#' Function that asks the user to input their preferred binning interval.
#' This decision must be made after analyzing the previous histograms.
#' Input is in hours (1, 2, 3, or 4). This is later multiplied by 60 to get minutes.
#' Recommendation:
#'   User should choose the binning interval that shows a histogram with a rightward displacement.
#' @param 
#' @keywords choose binning
#' @export
#' @examples
#' choose_binning()

choose_binning <- function(){
  
  ###Function that asks the user to input their preferred binning interval.
  ###This decision must be made after analyzing the previous histograms.
  ###Input is in hours (1, 2, 3, or 4). This is later multiplied by 60 to get minutes.
  ###Recommendation:
  # User should choose the binning interval that shows a histogram with a rightward displacement.
  
  
  
  varEntryDialog <- function(vars, 
                             labels = vars,
                             fun = rep(list(as.character), length(vars)),
                             title = 'Variable Entry',
                             prompt = NULL) {
    
    
    stopifnot(length(vars) == length(labels), length(labels) == length(fun))
    
    # Create a variable to keep track of the state of the dialog window:
    # done = 0; If the window is active
    # done = 1; If the window has been closed using the OK button
    # done = 2; If the window has been closed using the Cancel button or destroyed
    done <- tclVar(0)
    
    tt <- tktoplevel()
    tkwm.title(tt, title)	
    entries <- list()
    tclvars <- list()
    
    # Capture the event "Destroy" (e.g. Alt-F4 in Windows) and when this happens, 
    # assign 2 to done.
    tkbind(tt,"<Destroy>",function() tclvalue(done)<-2)
    
    for(i in seq_along(vars)) {
      tclvars[[i]] <- tclVar("")
      entries[[i]] <- tkentry(tt, textvariable=tclvars[[i]])
    }
    
    doneVal <- as.integer(tclvalue(done))
    results <- list()
    
    reset <- function() {
      for(i in seq_along(entries)) {
        tclvalue(tclvars[[i]]) <<- ""
      }
    }
    reset.but <- tkbutton(tt, text="Reset", command=reset)
    
    cancel <- function() {
      tclvalue(done) <- 2
    }
    cancel.but <- tkbutton(tt, text='Cancel', command=cancel)
    
    submit <- function() {
      for(i in seq_along(vars)) {
        tryCatch( {
          results[[vars[[i]]]] <<- fun[[i]](tclvalue(tclvars[[i]]))
          tclvalue(done) <- 1
        },
        error = function(e) { tkmessageBox(message=geterrmessage()) },
        finally = { }
        )
      }
    }
    submit.but <- tkbutton(tt, text="Submit", command=submit)
    
    if(!is.null(prompt)) {
      tkgrid(tklabel(tt,text=prompt), columnspan=3, pady=10)
    }
    
    for(i in seq_along(vars)) {
      tkgrid(tklabel(tt, text=labels[i]), entries[[i]], pady=10, padx=10, columnspan=4)
    }
    
    tkgrid(submit.but, cancel.but, reset.but, pady=10, padx=10, columnspan=3)
    tkfocus(tt)
    
    # Do not proceed with the following code until the variable done is non-zero.
    #   (But other processes can still run, i.e. the system is not frozen.)
    tkwait.variable(done)
    
    if(tclvalue(done) != 1) {
      results <- NULL
    }
    
    tkdestroy(tt)
    return(results)
  }
  
  
  
  
  
  minutesperbin <<- as.numeric(varEntryDialog(vars=c('Var1'), labels=c('Based on the histograms.\nWhich binning interval do you prefer?'), fun=c(
    function(x) {
      x <- as.numeric(x)*60
      # if(x >= 0 & x <= 10) {
      #   return(x)
      # } else {
      #   stop("Why didn't you follow instruction!\nPlease enter a number between 0 and 10.")
      # }
    } )))
  
  
  
}
