p_autocorrelation <-
function(CatBins=CatBins,LagPcnt=1,Avg=FALSE,modulo=1440){
  
  DataList <- CatBins$DataList
    
  fileNum <- 1
  
  startData <-1
  TimeBins<-CatBins$TimeBins
  startX<-2    #  time is in column 1
  startDark <-as.character(format(as.POSIXct(TimeBins[startData], origin="1970-01-01",tz="GMT"),"%H:%M:%S"))    #  get index of first darkness value
  thisTime <- format(Sys.time(), "%b %d, %Y - %H:%M:%S");
  nameVector = CatBins$binNames[-1]     # exclude the DateTime header name
  endXrel<-endX-startX+1
  for (cnt in 1:CatBins$plotCnt) {      #  1 plot per animal, for all animals 
    curX<-cnt+startX-1
    MaxLag <- round((CatBins$dataPts/CatBins$dayPts)*LagPcnt)*CatBins$dayPts        #dayPts is really pts in a modulus (chosen period)
    if (MaxLag<CatBins$dayPts){     #  cannot be less than one period
      MaxLag<-CatBins$dayPts
    }
    
    getACF <- acf(DataList[cnt,],main="",type="correlation",ylab="Correlation coefficient (r)",plot = FALSE, lag.max = MaxLag,col = "white")
    yACF <- as.numeric(getACF$acf)
    
    for(q in seq(from=1, to=length(yACF))){
      nantest <- is.nan(yACF[q])
      if(nantest==TRUE){
        yACF[q]=0
      }
    }
    
    auto[[length(auto)+1]] <- yACF
    xACF <- as.numeric(seq(from = 0, to = length(yACF)-1, by = 1))
    plot(xACF,yACF,type="l",col="blue",ylim=c(-1,1),ylab="Correlation Coefficient")
    
    abline(v=seq(from=0, to=MaxLag, by=(CatBins$binsPerDay)),xaxt="n",col="darkslategray",lty="dotted")
    abline(h=0,col="black")
    mtext(text=paste(CatBins$binNames[2]),side=3,outer=TRUE,padj=1.5)
    if (cnt==1){
      fileMatrix<-getACF$lag
    }
  }
}
